#include <bits/stdc++.h>

using namespace std;

#define MaxN 100000

struct Tacka
{
    int x, y;
};

long double vp(Tacka a, Tacka b, Tacka c)
{
    long double g=(a.x - c.x)*(b.y - c.y) - (b.x - c.x)*(a.y - c.y);
    return g;
}

long double povrsina (Tacka a, Tacka b, Tacka c)
{
    return 0.5*abs(vp(a, b, c));
}

int main()
{
    int n;
    cin>>n;
    Tacka a[MaxN];
    for (int i=0; i<n; i++)
    {
        cin>> a[i].x >> a[i].y;
    }
    if (n==4)
    {
        long double p1, p2, p3, p4;
        p1=povrsina (a[0], a[1], a[2]);
        p2=povrsina (a[0], a[1], a[3]);
        p3=povrsina (a[1], a[2], a[3]);
        p4=povrsina (a[0], a[2], a[3]);
        cout<< min(min(p1, p2), min(p3, p4));
    }

    return 0;
}